<template>
  <data-table ref="datatable" :get-data="getUsers">
    <template slot="table-toolbar">
      <div class="md-toolbar-section-start">
        <h1 class="md-title">Users</h1>
      </div>

      <md-field class="md-field-filter-status">
        <label for="kyc_status">KYC status</label>
        <md-select
          name="kyc_status"
          v-model="filterKYCStatus"
          id="kyc_status"
          @input="refreshDataTable"
          md-dense>
          <md-option :value="''"></md-option>
          <md-option
            :value="index"
            v-for="(status, index) in kycStatuses"
            :key="status">
            {{ status }}
          </md-option>
        </md-select>
      </md-field>

      <md-field md-clearable class="md-field-search md-toolbar-section-end">
        <md-input placeholder="Search by name or email ..." v-model="search" @input="searchUsers" />
      </md-field>
    </template>

    <md-table-head>#</md-table-head>
    <md-table-head data-sort-field="id">User ID</md-table-head>
    <md-table-head data-sort-field="name">Name</md-table-head>
    <md-table-head data-sort-field="email">Email</md-table-head>
    <md-table-head>Kyc Status</md-table-head>
    <md-table-head class="text-center"></md-table-head>

    <template slot="body" slot-scope="{ item, index }">
      <md-table-row >
        <md-table-cell> {{ index + 1 }}</md-table-cell>
        <md-table-cell>{{ item.id }}</md-table-cell>
        <md-table-cell>{{ item.name }}</md-table-cell>
        <md-table-cell >{{ item.email }}</md-table-cell>
        <md-table-cell :class="kycStatuses[item.kyc_status]">{{ kycStatuses[item.kyc_status] }}</md-table-cell>
        <md-table-cell class="text-center">
          <a v-if="item.kyc_status && item.user_kyc" target="_blank"
             :href="`${subHost}/checkus#/applicants/${item.user_kyc.applicant_id}`" >Kyc info</a>
        </md-table-cell>
      </md-table-row>
    </template>

  </data-table>
</template>
<script>
import rf from '../../../common/requests/RequestFactory';

export default {
  data () {
    return {
      kycStatuses: ['Unverified', 'Pending', 'Verified', 'Rejected'],
      search: '',
      filterKYCStatus: '',
      subHost: SUM_SUB_HOST,
    };
  },
  methods: {
    searchUsers: _.debounce(function () {
      this.refreshDataTable();
    }, 500),

    async getUsers (params) {
      const meta = Object.assign({}, {
        role: 'user',
        like_operator: 'or',
        like: {
          name: this.search,
          email: this.search
        },
        kyc_status: this.filterKYCStatus,
        with: 'userKyc',
      });

      return rf.getRequest('UserRequest').getAll(Object.assign({}, params, meta));
    },

    refreshDataTable () {
      this.$refs.datatable.refresh();
    }
  },
};
</script>

<style lang="scss" scoped>
  .md-field-filter-status {
    margin-right: 15px;
    max-width: 300px;
  }

  .md-field-search {
    max-width: 400px;
  }

  .md-card .md-card-content {
    padding: 0px 20px;
  }

  .md-card {
    margin: 0px;
  }

  .Univerified {
    color: #8a6d3b;
    font-weight: 700;
  }
  .Verified {
    color: #3c763d;
    font-weight: 700;
  }
  .Rejected {
    color: #a94442;
    font-weight: 700;
  }
</style>
